<?php

require_once('connect.client.php');

// check command line parameters are correct:
if (count($argv) != 4) {
    echo "Usage: connect.punch.php <employee_number> <punch_type_id> <punch_status_id>";
} else if (!is_numeric($argv[1])) {
    echo "Error: Employee Number must be numeric";
} else if (!is_numeric($argv[2])) {
    echo "Error: Punch Type ID must be numeric";
} else if (!is_numeric($argv[3])) {
    echo "Error: Punch Status ID must be numeric";
} else {
    // log in
    $factory = new TimeTrexCommandLineClientFactory();
    $client = $factory->makeTimeTrexClient();
    $api_session = $client->run();
    if ($client->getTimeTrexSessionId()) {
        $employeeId = (int) $argv[1];
        $user = new TimeTrexClientUser();
        $user_data = $user->getUserData($employeeId);
        if ($user->getResult() == TimeTrexClientUser::SUCCESS) {
            $userId = $user_data[0]['id'];
            $punchTypeId = (int) $argv[2];
            $punchStatusId = (int) $argv[3];
            $punch = new TimeTrexClientPunch();
            $continue = $punch->DoPunch($userId, $punchTypeId, $punchStatusId);
        }
    } else {
        echo "Error: could not log in. Please check logindetails.php.";
    }
    $api_session->Logout();
}

class TimeTrexClientPunch {

    public function DoPunch($userId, $punchTypeId, $punchStatusId) {
        $continue = false;

        // switch user to the one with $userId
        $factory = new TimeTrexCommandLineClientFactory();
        $client = $factory->makeTimeTrexClient();
        if ($client->switchUser($userId)) {
            $punch_obj = new TimeTrexClientAPI('Punch');
            if ($punch_obj == false) {
                echo "CONNECTION ERROR - punch_obj";
            } else {
                $punch_data = array(
                    'user_id' => $userId,
                    'type_id' => $punchTypeId,
                    'status_id' => $punchStatusId,
                    'time_stamp' => strtotime('now'),
                );

                $result = $punch_obj->setUserPunch($punch_data);
                if ($result == false) {
                    echo "CONNECTION ERROR - setUserPunch";
                } else {
                    $result = $result->getResult();
                    if ($result == false) {
                        echo "PLEASE WAIT AT LEAST ONE MINUTE BETWEEN PUNCHES!";
                    } else {
                        echo "Punch Complete";
                        $continue = true;
                    }
                }
            }
        }
        return $continue;
    }

}
